<?php

function ipay88_config() 
{
	$configarray = 	array("FriendlyName" => array("Type" => "System", "Value"=>"iPay88"),
     				
					"mcode" => array(	"FriendlyName" 	=> "Merchant Code", 
										"Type" 			=> "text", 
										"Size" 			=> "20"),
     				
					"mkey" 	=> array(	"FriendlyName" 	=> "Merchant Key", 
										"Type" 			=> "text", 
										"Size" 			=> "20"),
										
					"instructions" => array( "FriendlyName" => "Payment Instructions", 
											 "Type" 		=> "textarea", 
											 "Rows" 		=> "5"),
     				
					"environment"  => array( "FriendlyName" => "Enable Sandbox", 
											 "Type" 		=> "yesno", 
											 "Description" 	=> "Sandbox mode provides you with a chance to test your gateway integration with iPay88. The payment requests will be send to the iPay88 sandbox URL. Untick to start accepting Live payments."));										 					
	return $configarray;
}


function iPay88_signature($source)
{
	return base64_encode(hex2bin(sha1($source)));
}


if ( !function_exists('hex2bin') )
{
	function hex2bin($hexSource)
	{
		$bin = '';
		for ($i=0;$i<strlen($hexSource);$i=$i+2)
		{
			$bin .= chr(hexdec(substr($hexSource,$i,2)));
		}
		return $bin;
	}
}


function ipay88_link($params) 
{
	global $CONFIG;

	// Gateway Specific Variables
	$gatewaymcode		= $params['mcode'];
	$gatewaymkey 		= $params['mkey'];
	$environment		= $params['environment'];

	if($environment == "on")
	{ 
		$action_ipay88 = "https://sandbox.ipay88.co.id/epayment/entry.asp";
	}
	
	else
	{
		$action_ipay88 = "https://payment.ipay88.co.id/epayment/entry.asp";
	}

	// Invoice Variables
	$invoiceId 		= $params['invoiceid'];
    $description 	= $params["description"];
    $amount			= $params['amount'];
    $currencyCode 	= $params['currency'];

	// Client Variables
	$firstname 	= $params['clientdetails']['firstname'];
	$lastname 	= $params['clientdetails']['lastname'];
	$email 		= $params['clientdetails']['email'];
	$address1	= $params['clientdetails']['address1'];
	$address2 	= $params['clientdetails']['address2'];
	$city 		= $params['clientdetails']['city'];
	$state 		= $params['clientdetails']['state'];
	$postcode 	= $params['clientdetails']['postcode'];
	$country 	= $params['clientdetails']['country'];
	$phone 		= $params['clientdetails']['phonenumber'];

	$responseurl 	= $CONFIG['SystemURL']."/modules/gateways/callback/ipay88_callback.php";
	$backendurl 	= $CONFIG['SystemURL']."/modules/gateways/callback/ipay88_backendcallback.php";

	// System Variables
	$companyname 	= $params['companyname'];
	$systemurl 		= $params['systemurl'];
	$currency 		= $params['currency'];

	// Enter your code submit to the gateway...

	$AMT_IDR 	= ($amount*100);
	$AMT_IDR 	= round($AMT_IDR, -2);
	$strToHash 	= $gatewaymkey . $gatewaymcode . $invoiceId . str_replace('.','',str_replace(',','',$AMT_IDR)) .$currency;
	$encrypstr 	= iPay88_signature($strToHash);


	$code =
	'<br><center>
	
	<form method="post" name="ePayment" action="'.$action_ipay88.'">

		<input type="hidden" name="MerchantCode" value="'.$gatewaymcode.'">
		<input type="hidden" name="PaymentId"    value="">
		<input type="hidden" name="RefNo" 		 value="'.$invoiceId.'">
		<input type="hidden" name="Amount" 		 value="'.$AMT_IDR.'">
		<input type="hidden" name="Currency" 	 value="'.$currency.'">
		<input type="hidden" name="ProdDesc" 	 value="'.$description.'">
		<input type="hidden" name="UserName" 	 value="'.$firstname.' '.$lastname.'">
		<input type="hidden" name="UserEmail" 	 value="'.$email.'">
		<input type="hidden" name="UserContact"  value="'.$phone.'">
		<input type="hidden" name="Remark" 		 value="'.$description.'">
		<input type="hidden" name="Lang" 		 value="UTF-8">
		<input type="hidden" name="Signature" 	 value="'.$encrypstr.'">
		<input type="hidden" name="ResponseURL"  value="'.$responseurl.'">
		<input type="hidden" name="BackendURL" 	 value="'.$backendurl.'">
		
		<input type="submit" value="Proceed Payment" name="Submit" class="btn btn-primary">

	</form><center>';

	return $code;
}

?>